/*
 *  File Name       : RSPF0_spu_driver.h
 *  Function        : SPU OPEN SOUND I/F
 *  Release Version : Ver 1.00
 *  Release Date    : 2011/11/30
 *
 *  Copyright (C) 2011 Renesas Electronics Corporation
 *
 *  This program is free software;you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by Free
 *  Softwere Foundation; either version 2 of License, or (at your option) any
 *  later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY;
 *  without even the implied warrnty of MERCHANTABILITY or FITNESS FOR A
 *  PARTICULAR PURPOSE.
 *  See the GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program;
 *  If not, write to the Free Software Foundation, Inc., 51 Franklin St,
 *  Fifth Floor, Boston, MA  02110-1301  USA
 *
 */
#ifndef __RSPF0_SPU_DRIVER_H__
#define __RSPF0_SPU_DRIVER_H__

#include "RSPF0_spu_driver_prefix.h"

typedef struct {
	void (*read)(unsigned long *, unsigned long *, unsigned long size);
	void (*write)(unsigned long *, unsigned long *, unsigned long size);
	long (*wait_for_event)(unsigned long timeout);
	long (*set_event)(void);
	long (*enter_critical_section)(void);
	long (*leave_critical_section)(void);
} SPUDRV_STRUCT(UserFunc);

extern long SPUDRV_FUNC(Open)(
	unsigned long dsp_id,
	void (*receive_callback)(unsigned long, unsigned long *, unsigned long),
	SPUDRV_STRUCT(UserFunc) * func,
	unsigned long download,
	unsigned long address_mode,
	const unsigned long *data[3],
	const unsigned long size[3],
	unsigned long param[8]);

extern long SPUDRV_FUNC(Close)(unsigned long dsp_id);

extern long SPUDRV_FUNC(SendApi)(
	unsigned long dsp_id,
	unsigned long api,
	unsigned long *data,
	unsigned long size);

extern void SPUDRV_FUNC(ISR)(unsigned long dsp_id);

#endif /* __RSPF0_SPU_DRIVER_H__ */

MODULE_LICENSE("GPL");
MODULE_DESCRIPTION("SPU OPEN SOUND I/F Ver 1.0");
MODULE_AUTHOR("Renesas Electronics");
